=== debian/changelog ===
obs-studio (30.2.3+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1097496)

 -- Adrian Bunk <bunk@debian.org>  Sun, 05 Oct 2025 20:35:32 +0300

obs-studio (30.2.3+dfsg-3) unstable; urgency=medium

  * Backport stephematician's patch for v4l2loopback-0.14 compat.
    Thanks to Joao Eriberto Mota Filho <eriberto@debian.org>
    (Closes: #1101728, #1101351)
  * Make debian/latest the default packaging branch
  * Apply 'wrap-and-sort -ast'
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 25 Apr 2025 20:49:45 +0200

obs-studio (30.2.3+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Revert "Drop patches obsoleted by upstream"
  * Fix obs-ffmpeg-mux patch (Closes: #1079732)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 29 Aug 2024 07:56:20 +0200

obs-studio (30.2.3+dfsg-1) unstable; urgency=medium

  * New upstream version 30.2.3+dfsg
    (Closes: #1072439, #1075327)

  [ Sebastian Ramacher ]
  * Remove myself from Uploaders

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Update patches
    + Drop patches obsoleted by upstream
    + Refresh patches
    + Update patches
  * Install obs-websocket CMake snippets
  * Explicitly disable obs-browser for now (missing CEF)
  * Do not treat warnings as errors
  * Add uthash-dev and pkgconf as B-D
  * Update libobs0t64.symbols
  * Update d/watch to use upstream's handmade source package
    + Drop extra 'websocket' component
    + Drop 'websocket' component magic in d/rules and d/clean
  * Update copyright information
    + Update d/copyright
    + Remove obsolete Files-Excluded stanzas
    + Re-generate d/copyright_hints
  * Update lintian-overrides
  * Drop copyright for excluded uthash
  * fix more spelling errors:
  * Forward spelling error patch

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 20 Aug 2024 16:17:53 +0200
